﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub
'Return the following information in an array of String:
'BUILD Information
'System Properties
'Memory Info
'Display Info
'SystemAvailableFeatures
'SystemSharedLibraryNames
Public Sub deviceInfo() As String()

Dim devInfo() As String
Dim dummy As Int  = 0
devInfo = nativeMe.RunMethod("deviceInfo",Array(dummy))
Return devInfo

End Sub
Public Sub ReadCPUinfo() As String

Dim cpuInfo As String
Dim dummy As Int  = 0
cpuInfo = nativeMe.RunMethod("ReadCPUinfo",Array(dummy))
Return cpuInfo

End Sub


#If Java

import java.util.Enumeration;
import java.util.Properties;

//import android.support.v7.app.ActionBarActivity;
import android.util.DisplayMetrics;
import android.app.ActivityManager;
import android.app.ActivityManager.MemoryInfo;
import android.content.pm.FeatureInfo;
import android.os.Build;
import android.os.Bundle;
import android.widget.TextView;
import android.content.Context;
import android.view.WindowManager;
import android.app.Activity;  
import android.content.pm.PackageManager;
import java.io.InputStream;
import java.io.IOException;


public String[] deviceInfo(int dummy) {
  String[] mInfo = new String[250];
  int cntr = 0;

  String strInfo = "Build.VERSION.SDK_INT: " + Build.VERSION.SDK_INT + "\n"
   + "Build.BOARD: " + Build.BOARD + "\n"
   + "Build.BOOTLOADER: " + Build.BOOTLOADER + "\n"
   + "Build.BRAND: " + Build.BRAND + "\n"
   + "Build.DEVICE: " + Build.DEVICE + "\n"
   + "Build.DISPLAY: " + Build.DISPLAY + "\n"
   + "Build.FINGERPRINT: " + Build.FINGERPRINT + "\n"
   + "Build.HARDWARE: " + Build.HARDWARE + "\n"
   + "Build.HOST: " + Build.HOST + "\n"
   + "Build.ID: " + Build.ID + "\n"
   + "Build.MANUFACTURER: " + Build.MANUFACTURER + "\n"
   + "Build.MODEL: " + Build.MODEL + "\n"
   + "Build.PRODUCT: " + Build.PRODUCT + "\n"
   + "Build.TAGS: " + Build.TAGS + "\n"
   + "Build.TIME: " + Build.TIME + "\n"
   + "Build.TYPE: " + Build.TYPE + "\n"
   + "Build.USER: " + Build.USER + "\n";
   
   mInfo[0] = "Build.VERSION.SDK_INT: " + Build.VERSION.SDK_INT;
   mInfo[1] = "Build.BOARD: " + Build.BOARD;
   mInfo[2] = "Build.BOOTLOADER: " + Build.BOOTLOADER;
   mInfo[3] = "Build.BRAND: " + Build.BRAND;
   mInfo[4] = "Build.DEVICE: " + Build.DEVICE;
   mInfo[5] = "Build.DISPLAY: " + Build.DISPLAY;
   mInfo[6] = "Build.FINGERPRINT: " + Build.FINGERPRINT;
   mInfo[7] = "Build.HARDWARE: " + Build.HARDWARE;
   mInfo[8] = "Build.HOST: " + Build.HOST;
   mInfo[9] = "Build.ID: " + Build.ID;
   mInfo[10] = "Build.MANUFACTURER: " + Build.MANUFACTURER;
   mInfo[11] = "Build.MODEL: " + Build.MODEL;
   mInfo[12] = "Build.PRODUCT: " + Build.PRODUCT; 
   mInfo[13] = "Build.TAGS: " + Build.TAGS;
   mInfo[14] = "Build.TIME: " + Build.TIME;
   mInfo[15] = "Build.TYPE: " + Build.TYPE;
   mInfo[16] = "Build.USER: " + Build.USER;
   mInfo[17] = " ";
   
   cntr = 17;
  strInfo += "\n - System Properties - \n";
  cntr = cntr + 1;
  mInfo[cntr] = " - System Properties - ";
  Properties properties = System.getProperties();
  Enumeration<?> propertyNames = properties.propertyNames();
  while (propertyNames.hasMoreElements()) {
   cntr = cntr + 1;
   String key = (String)propertyNames.nextElement();
   String value = properties.getProperty(key);
   strInfo += key + " : " + value + "\n"; 
   mInfo[cntr] = key + " : " + value;
  }
  
  cntr = cntr + 1;
  mInfo[cntr] = " ";
  strInfo += "\n - Memory Info - \n";
  cntr = cntr + 1;
  mInfo[cntr] =  " - Memory Info - ";
  MemoryInfo memoryInfo = new MemoryInfo();
  ActivityManager activityManager = (ActivityManager)BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
  activityManager.getMemoryInfo(memoryInfo);
//  strInfo += "Total Memory : " + memoryInfo.totalMem + "\n"; API Level 16
  cntr = cntr + 1;
//  mInfo[cntr] = "Total Memory : " + memoryInfo.totalMem;
  mInfo[cntr] = "";
  strInfo += "Available Memory : " + memoryInfo.availMem + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "Available Memory : " + memoryInfo.availMem;
  strInfo += "Threshold : " + memoryInfo.threshold + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "Threshold : " + memoryInfo.threshold;
  strInfo += "Low Memory : " + memoryInfo.lowMemory + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "Low Memory : " + memoryInfo.lowMemory;

  cntr = cntr + 1;
  mInfo[cntr] = " ";
  strInfo += "\n - Display - \n";
  cntr = cntr + 1;
  mInfo[cntr] = " - Display - ";
  
  DisplayMetrics metrics = new DisplayMetrics();
  ((WindowManager) BA.applicationContext.getSystemService(Context.WINDOW_SERVICE)).getDefaultDisplay().getMetrics(metrics);
  strInfo += "widthPixels : " + metrics.widthPixels + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "widthPixels : " + metrics.widthPixels;
  strInfo += "heightPixels : " + metrics.heightPixels + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "heightPixels : " + metrics.heightPixels;
  strInfo += "xdpi : " + metrics.xdpi + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "xdpi : " + metrics.xdpi;
  strInfo += "ydpi : " + metrics.ydpi + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "ydpi : " + metrics.ydpi;
  strInfo += "density : " + metrics.density + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "density : " + metrics.density;
  strInfo += "densityDpi : " + metrics.densityDpi + "\n";
  cntr = cntr + 1;
  mInfo[cntr] =  "densityDpi : " + metrics.densityDpi;
  strInfo += "scaledDensity : " + metrics.scaledDensity + "\n";
  cntr = cntr + 1;
  mInfo[cntr] = "scaledDensity : " + metrics.scaledDensity;

  cntr = cntr + 1;
  mInfo[cntr] = " ";
  strInfo += "\n - SystemAvailableFeatures - \n"; 
  cntr = cntr + 1;
  mInfo[cntr] = " - SystemAvailableFeatures - ";
  FeatureInfo[] featureInfo  = 
   BA.applicationContext.getPackageManager().getSystemAvailableFeatures();
  for(int i=0; i<featureInfo.length; i++){
   strInfo += featureInfo[i].toString() + "\n";
   cntr = cntr + 1;
   mInfo[cntr] = featureInfo[i].toString();
  }
  cntr = cntr + 1;
  mInfo[cntr] = " ";  
  strInfo += "\n - SystemSharedLibraryNames - \n"; 
  cntr = cntr + 1;
  mInfo[cntr] = " - SystemSharedLibraryNames - ";
  String[] systemSharedLibraryNames = 
   BA.applicationContext.getPackageManager().getSystemSharedLibraryNames();
  for(int i=0; i<systemSharedLibraryNames.length; i++){
   strInfo += systemSharedLibraryNames[i] + "\n";
   cntr = cntr + 1;
   mInfo[cntr] = systemSharedLibraryNames[i];
  }
//  BA.Log("" + cntr);
  return mInfo;
}


 public String ReadCPUinfo(int dummy){
	ProcessBuilder cmd;
	StringBuffer strMemory = new StringBuffer();
	ActivityManager actvityManager = (ActivityManager) BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
	ActivityManager.MemoryInfo mInfo = new ActivityManager.MemoryInfo ();
	actvityManager.getMemoryInfo( mInfo );
	strMemory.append("Available Memory : ");
	strMemory.append(mInfo.availMem/1048576L);
	strMemory.append("\n");
	strMemory.append("\n");
	String result=strMemory.toString();
	try {
	  String[] args = {"/system/bin/cat", "/proc/meminfo"};
	  cmd = new ProcessBuilder(args);
	  Process process = cmd.start();
	  InputStream in = process.getInputStream();
	  byte[] re = new byte[1024];
	  while(in.read(re) != -1){
	    result = result + new String(re);
	  }
	  in.close();
	} 
	  catch(IOException ex) {
	}
    return result;
}



#End If 